"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .passthroughbody import PassThroughBody, PassThroughBodyTypedDict
from apideck_unify.types import BaseModel
from typing import List, Optional
from typing_extensions import NotRequired, TypedDict


class CreateFolderRequestTypedDict(TypedDict):
    name: str
    r"""The name of the folder."""
    parent_folder_id: str
    r"""The parent folder to create the new file within. This can be an ID or a path depending on the downstream folder. Please see the connector section below to see downstream specific gotchas."""
    description: NotRequired[str]
    r"""Optional description of the folder."""
    drive_id: NotRequired[str]
    r"""ID of the drive to create the folder in."""
    pass_through: NotRequired[List[PassThroughBodyTypedDict]]
    r"""The pass_through property allows passing service-specific, custom data or structured modifications in request body when creating or updating resources."""


class CreateFolderRequest(BaseModel):
    name: str
    r"""The name of the folder."""

    parent_folder_id: str
    r"""The parent folder to create the new file within. This can be an ID or a path depending on the downstream folder. Please see the connector section below to see downstream specific gotchas."""

    description: Optional[str] = None
    r"""Optional description of the folder."""

    drive_id: Optional[str] = None
    r"""ID of the drive to create the folder in."""

    pass_through: Optional[List[PassThroughBody]] = None
    r"""The pass_through property allows passing service-specific, custom data or structured modifications in request body when creating or updating resources."""
